indexing
	description: "Token on TRIO Board"
	author: "Dr. Thomas Tensi"
	date: "$Date$"
	revision: "$Revision$"

class
	BOARD_TOKEN

inherit
	COMPARABLE
		redefine
			infix "<", is_equal
		end

create
	make

feature {NONE} -- Initialization

	make (v : INTEGER) is
		-- Initialize `Current'.
		do
			value := v
		end


feature -- Access

	value : INTEGER


feature -- Comparison

	infix "<" (other: like Current): BOOLEAN is
			-- token order
		do
			Result := (value < other.value)
		end

	-- --------------------

	is_equal (other: like Current): BOOLEAN is
			-- token equality
		do
			Result := (value = other.value)
		end


feature -- Conversion

	to_string : STRING is
			-- convert `Current' to STRING
		local
			temp : STRING
		do
			create temp.make_empty
			temp.append_integer(value)
			Result := temp
		end


feature {NONE} -- Implementation


end
