indexing
	description: "List of all available board token objects"
	author: "Dr. Thomas Tensi"
	date: "$Date$"
	revision: "$Revision$"

class
	BOARD_TOKEN_LIST


create
	make


feature -- Initialization

	make (zeroes_are_allowed : BOOLEAN) is
			-- Initializes `Current' to a list of allowed tokens
		local
			i : INTEGER
			token : BOARD_TOKEN
		do
			if zeroes_are_allowed then
				min_value := 0
			else
				min_value := 1
			end

			create info.make(min_value, max_value)

			from
				i := min_value
			until
				i > max_value
			loop
				create token.make(i)
				info[i] := token
				i := i + 1
			end
		end


feature -- Access
	min_value : INTEGER      -- minimum allowed value for a token
	max_value : INTEGER is 9 -- maximum allowed value for a token

feature -- Status setting

	start is
		do
			cursor := min_value
		end


feature -- Status report

	item : BOARD_TOKEN is
		do
			Result := info[cursor]
		end


feature -- Cursor movement

	forth is
		do
			cursor := cursor + 1

			if cursor > max_value then
				start
			end
		end


feature {NONE} -- Implementation

	cursor : INTEGER
	info : ARRAY[BOARD_TOKEN]

end
