indexing
	description: "High Score Window for TRIO Game"
	author: "Dr. Thomas Tensi"
	date: "$Date$"
	revision: "$Revision$"

class
	HIGH_SCORE_WINDOW

inherit
	WEL_FRAME_WINDOW
		redefine
			on_timer
		end

	WEL_LVCF_CONSTANTS
		export
			{NONE} all
		end

	RESOURCE_CONSTANTS


create
	make


feature {NONE} -- Initialization

	make (application : ROOT_CLASS;  parent_window: WEL_WINDOW) is
		local
 			column: WEL_LIST_VIEW_COLUMN
 			entry_list : LIST[STRING]
 			field_list : LIST[STRING]
			font : WEL_FONT
 			header_list : LIST[STRING]
 			high_score_list : HIGH_SCORE_TABLE
 			i : INTEGER
			log_font : WEL_LOG_FONT
 			row  : WEL_LIST_VIEW_ITEM
 			st : STRING
 		do
 			resource_manager := application.resource_manager
 			st := resource_manager.get_cd_string(rsc_cd_string_highscoredlg_title)
			make_child(parent_window, st)
			resize(430,250)
			move(parent_window.width - width, parent_window.height - height)

			st := resource_manager.get_cd_string(rsc_cd_string_highscoredlg_headers)
			header_list := st.split('%T')

			-- configure list view
			create listview.make(current, 0,0, width, height, -1)
			st := resource_manager.get_cd_string(rsc_cd_font_highscoredlg_name)
			create log_font.make(rsc_font_highscoredlg_size, st)
			create font.make_indirect(log_font)
			listview.set_font(font)

			-- add columns
			create column.make
			column.set_width(50)
			column.set_alignment(Lvcfmt_center)
			column.set_text(header_list[1])
			listview.append_column(column)
			create column.make
			column.set_width(150)
			column.set_alignment(Lvcfmt_left)
			column.set_text(header_list[2])
			listview.append_column(column)
			create column.make
			column.set_width(100)
			column.set_alignment(Lvcfmt_left)
			column.set_text(header_list[3])
			listview.append_column(column)
			create column.make
			column.set_width(100)
			column.set_alignment(Lvcfmt_right)
			column.set_text(header_list[4])
			listview.append_column(column)

			-- put score list into list view
			create high_score_list.make
			entry_list := high_score_list.to_string.split('%N')

			from
				i := 1
			until
				i > entry_list.count
			loop
				field_list := (entry_list[i]).split('%T')

				if field_list.count = 3 then
					create row.make
					row.set_iitem(i - 1)
					listview.insert_item(row)

					create st.make_empty
					st.append_integer(i)
					st.append_character('.')
					listview.set_cell_text(0, row.iitem, st)
					listview.set_cell_text(1, row.iitem, field_list[1])
					listview.set_cell_text(2, row.iitem, field_list[2])
					listview.set_cell_text(3, row.iitem, field_list[3])
				end

				i := i + 1
			end

			-- set ten second display time
			set_timer(window_display_timer, 10000)
		end


feature {NONE} -- Event handling

	on_timer (timer_id: INTEGER) is
			-- react on timer with `timer_id'.
		require else
			valid_timer: timer_id = window_display_timer
		do
			destroy
		end


feature {NONE} -- Implementation

	listview : WEL_LIST_VIEW
    resource_manager : RESOURCE_MANAGER
	window_display_timer : INTEGER is 1

end
