indexing
	description: "Objects that ..."
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	SPLASH_WINDOW

inherit
	WEL_MODELESS_DIALOG
		redefine
			on_timer,
			setup_dialog
		end

	RESOURCE_CONSTANTS
		export
			{NONE} all
		end

	WEL_COLOR_CONSTANTS
		export
			{NONE} all
		end

create
	make

feature {NONE} -- Initialization

	make (parent_window : WEL_WINDOW; global_resource_manager : RESOURCE_MANAGER) is
			-- Make the splash window
		do
			resource_manager := global_resource_manager
			make_by_id(parent_window,
					   resource_manager.adapt_id(rsc_cd_id_introdlg))
			create description.make_by_id(current,
					   resource_manager.adapt_id(rsc_cd_id_introdlg_text))
		end


feature -- Basic operations

	setup_dialog is
		local
			new_x : INTEGER
			new_y : INTEGER
			dialog_title : STRING
		do
			dialog_title :=
				resource_manager.get_cd_string(rsc_cd_string_introdlg_text)
			description.set_text(dialog_title)
			new_x := (parent.width - width) // 2
			new_y := (parent.height - height) // 2
			move(new_x, new_y)
			set_timer(splash_timer, 3000)
		end


feature {NONE} -- Implementation

	resource_manager : RESOURCE_MANAGER
	description : WEL_STATIC

	splash_timer   : INTEGER is 1


feature {NONE} -- Event Handling (local)

	on_timer (timer_id: INTEGER) is
			-- react on timer with `timer_id'.
		require else
			valid_timer: timer_id = splash_timer
		do
			destroy
		end


end
